/*******************************************************************************
 * FoxDialogBoxMessageAnnouncement generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDialogBoxMessageAnnouncement extends FoxDialogBoxMessageBase within FoxUI
    native(UI)
    config(UI);

struct native AnnouncementDialogBoxBannerItem
{
    var int nNumOfItems;
    var init string sBackgroundImage;
    var init string sIcon;
    var init string sIcon2;
    var init string sItemName;
    var int nItemIndex;
    var init string BackgroundImageURL;
    var Texture2DDynamic BackgroundTexture;

    structdefaultproperties
    {
        nNumOfItems=0
        sBackgroundImage=""
        sIcon=""
        sIcon2=""
        sItemName=""
        nItemIndex=0
        BackgroundImageURL=""
        BackgroundTexture=none
    }
};

struct native AnnouncementDialogBoxBannerItemConfig
{
    var string BackgroundImageRef;
    var string BackgroundImageURL;
    var string IconRef;
    var string IconRef2;
    var string TextLocTag;

    structdefaultproperties
    {
        BackgroundImageRef=""
        BackgroundImageURL=""
        IconRef=""
        IconRef2=""
        TextLocTag=""
    }
};

struct native AnnouncementDialogBoxProperties
{
    var init string HeaderText;
    var init string BodyText;
    var init string CloseButtonText;
    var init string CloseButtonIcon;
    var bool bCloseOnButtonPress;
    var array<AnnouncementDialogBoxBannerItem> BannerItems;
    var delegate<DialogButtonPressedDelegate> OnButtonPressed;

    structdefaultproperties
    {
        HeaderText=""
        BodyText=""
        CloseButtonText=""
        CloseButtonIcon=""
        bCloseOnButtonPress=false
        BannerItems=none
        But=None
    }
};

var protected transient AnnouncementDialogBoxProperties CurrentProperties;
var private bool bAutoMode;
var private bool bAnnouncementAutoModeIsOverride;
var private bool bInitialized;
var private string CurrentMD5;
var private int CurrentBannerItemIndex;
var private float CurrentBannerProgress;
var const config float TimePerBannerImage;
var private OnlineImageDownloaderWeb BannerImageDownloader;
var const localized string LocStringDefaultHeaderText;
var const localized string LocStringDefaultBodyText;
var const config array<config AnnouncementDialogBoxBannerItemConfig> DefaultBannerItems;
var const localized string LocStringOverrideHeaderText;
var const localized string LocStringOverrideBodyText;
var const config array<config AnnouncementDialogBoxBannerItemConfig> OverrideBannerItems;
var const localized string LocStringCloseButtonText;
var const config string CloseButtonIcon;

event ScriptTick(float DeltaTime)
{
    BannerImageDownloader.Tick(DeltaTime);
    //return;    
}

function array<AnnouncementDialogBoxBannerItem> GetArrayOfBannerItemsFromConfigEntries(const out array<AnnouncementDialogBoxBannerItemConfig> ConfigItems)
{
    local array<AnnouncementDialogBoxBannerItem> OutItems;
    local AnnouncementDialogBoxBannerItem CurrentItem;
    local int I;

    OutItems.Length = 0;
    I = 0;
    J0x17:
    // End:0x285 [Loop If]
    if(I < ConfigItems.Length)
    {
        CurrentItem.nNumOfItems = ConfigItems.Length;
        CurrentItem.nItemIndex = I;
        CurrentItem.sBackgroundImage = ((ConfigItems[I].BackgroundImageURL == "") ? ConfigItems[I].BackgroundImageRef : "");
        CurrentItem.sIcon = ConfigItems[I].IconRef;
        CurrentItem.sIcon2 = ConfigItems[I].IconRef2;
        CurrentItem.sItemName = ((ConfigItems[I].TextLocTag == "") ? "" : Localize("FoxDialogBoxMessageAnnouncement", ConfigItems[I].TextLocTag, "FoxGame"));
        CurrentItem.BackgroundImageURL = ConfigItems[I].BackgroundImageURL;
        OutItems.AddItem(CurrentItem);
        ++ I;
        // [Loop Continue]
        goto J0x17;
    }
    return OutItems;
    //return ReturnValue;    
}

// Export UFoxDialogBoxMessageAnnouncement::execCalculateMD5FromAnnouncementProperties(FFrame&, void* const)
native function string CalculateMD5FromAnnouncementProperties(const out AnnouncementDialogBoxProperties Properties);

function AnnouncementDialogBoxProperties GenerateDefaultAnnouncementProperties()
{
    local AnnouncementDialogBoxProperties Properties;

    Properties.HeaderText = LocStringDefaultHeaderText;
    Properties.BodyText = LocStringDefaultBodyText;
    Properties.CloseButtonText = LocStringCloseButtonText;
    Properties.CloseButtonIcon = CloseButtonIcon;
    Properties.BannerItems = GetArrayOfBannerItemsFromConfigEntries(DefaultBannerItems);
    Properties.OnButtonPressed = OnCloseButtonPressed;
    Properties.bCloseOnButtonPress = true;
    return Properties;
    //return ReturnValue;    
}

function AnnouncementDialogBoxProperties GenerateOverrideAnnouncementProperties()
{
    local AnnouncementDialogBoxProperties Properties;

    Properties.HeaderText = ((LocStringOverrideHeaderText != "") ? LocStringOverrideHeaderText : LocStringDefaultHeaderText);
    Properties.BodyText = ((LocStringOverrideBodyText != "") ? LocStringOverrideBodyText : LocStringDefaultBodyText);
    Properties.CloseButtonText = LocStringCloseButtonText;
    Properties.CloseButtonIcon = CloseButtonIcon;
    Properties.BannerItems = ((OverrideBannerItems.Length > 0) ? GetArrayOfBannerItemsFromConfigEntries(OverrideBannerItems) : GetArrayOfBannerItemsFromConfigEntries(DefaultBannerItems));
    Properties.OnButtonPressed = OnCloseButtonPressed;
    Properties.bCloseOnButtonPress = true;
    return Properties;
    //return ReturnValue;    
}

function Initialize()
{
    // End:0x82
    if(!bInitialized)
    {
        bInitialized = true;
        BannerImageDownloader = new (self) class'OnlineImageDownloaderWeb';
        BannerImageDownloader.__OnOnlineImageDownloaded__Delegate = OnBannerImageDownloaded;
        BannerImageDownloader.Initialize();
    }
    //return;    
}

function CloseDialog()
{
    // End:0x69
    if(BannerImageDownloader != none)
    {
        BannerImageDownloader.ClearAllDownloads();
        BannerImageDownloader.__OnOnlineImageDownloaded__Delegate = None;
        BannerImageDownloader = none;
    }
    super(FoxDialogBoxBase).CloseDialog();
    //return;    
}

// Export UFoxDialogBoxMessageAnnouncement::execGetTexturePath(FFrame&, void* const)
native function string GetTexturePath(Texture2DDynamic InTexture);

function OnBannerImageDownloaded(OnlineImageDownload CachedEntry)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x1BA [Loop If]
    if(I < CurrentProperties.BannerItems.Length)
    {
        // End:0x1AC
        if(CurrentProperties.BannerItems[I].BackgroundImageURL == CachedEntry.URL)
        {
            CurrentProperties.BannerItems[I].BackgroundTexture = CachedEntry.Texture;
            CurrentProperties.BannerItems[I].sBackgroundImage = Outer.MarkupImageString(GetTexturePath(CachedEntry.Texture));
            // End:0x1AC
            if(I == CurrentBannerItemIndex)
            {
                as_setBannerData(CurrentProperties.BannerItems[I]);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function bool ShowDialogAutomatic(optional bool bForceShow)
{
    local AnnouncementDialogBoxProperties Properties;
    local string LastSeenMD5;

    bForceShow = false;
    // End:0x66
    if((Outer.PCOwner == none) || Outer.PCOwner.ProfileSettings == none)
    {
        return false;
    }
    Initialize();
    bAutoMode = true;
    // End:0x114
    if((LocStringOverrideBodyText == "") && OverrideBannerItems.Length == 0)
    {
        LastSeenMD5 = Outer.PCOwner.ProfileSettings.GetLastSeenDefaultAnnouncementMD5();
        Properties = GenerateDefaultAnnouncementProperties();
        bAnnouncementAutoModeIsOverride = false;
    }
    // End:0x187
    else
    {
        LastSeenMD5 = Outer.PCOwner.ProfileSettings.GetLastSeenOverrideAnnouncementMD5();
        Properties = GenerateOverrideAnnouncementProperties();
        bAnnouncementAutoModeIsOverride = true;
    }
    CurrentMD5 = CalculateMD5FromAnnouncementProperties(Properties);
    // End:0x1E2
    if(bForceShow || CurrentMD5 != LastSeenMD5)
    {
        ShowDialog(Properties);
        return true;
    }
    // End:0x1EE
    else
    {
        CloseDialog();
        return false;
    }
    //return ReturnValue;    
}

function ShowDialog(const AnnouncementDialogBoxProperties Properties)
{
    local array<string> ImagesToDownload;
    local int I;

    Initialize();
    CurrentProperties = Properties;
    ToggleAllowEscape(CurrentProperties.bCloseOnButtonPress);
    BindDialogButtonPressedDelegate(CurrentProperties.OnButtonPressed);
    BindDialog(Outer.GetVariableObject("_root"), "w_newsDialogBox2.0");
    SetHeaderText(CurrentProperties.HeaderText);
    SetBodyText(CurrentProperties.BodyText);
    ui_setConfirmButton(CurrentProperties.CloseButtonText, CurrentProperties.CloseButtonIcon, "ei_acceptButtonPressed", "", true, true);
    Outer.Advance(0.0);
    as_SetNumofItems(CurrentProperties.BannerItems.Length);
    // End:0x32A
    if(CurrentProperties.BannerItems.Length > 0)
    {
        CurrentBannerItemIndex = 0;
        I = 0;
        J0x1DF:
        // End:0x29E [Loop If]
        if(I < CurrentProperties.BannerItems.Length)
        {
            // End:0x290
            if(CurrentProperties.BannerItems[I].BackgroundImageURL != "")
            {
                ImagesToDownload.AddItem(CurrentProperties.BannerItems[I].BackgroundImageURL);
            }
            ++ I;
            // [Loop Continue]
            goto J0x1DF;
        }
        as_setBannerData(CurrentProperties.BannerItems[CurrentBannerItemIndex]);
        Outer.Advance(0.0);
        // End:0x32A
        if(ImagesToDownload.Length > 0)
        {
            BannerImageDownloader.RequestOnlineImages(ImagesToDownload);
        }
    }
    //return;    
}

function OnCloseButtonPressed(FoxDialogBoxBase.EDialogBoxConfirmType CloseType)
{
    // End:0x17B
    if((bAutoMode && Outer.PCOwner != none) && Outer.PCOwner.ProfileSettings != none)
    {
        // End:0xD0
        if(bAnnouncementAutoModeIsOverride)
        {
            Outer.PCOwner.ProfileSettings.SetLastSeenOverrideAnnouncementMD5(CurrentMD5);
        }
        // End:0x122
        else
        {
            Outer.PCOwner.ProfileSettings.SetLastSeenDefaultAnnouncementMD5(CurrentMD5);
        }
        Outer.PCOwner.SaveProfile("Updating Last Seen Announcement MD5");
    }
    CloseDialog();
    //return;    
}

event ScrollToNextBannerItem()
{
    // End:0x88
    if(CurrentProperties.BannerItems.Length > 0)
    {
        CurrentBannerItemIndex = (CurrentBannerItemIndex + 1) % CurrentProperties.BannerItems.Length;
        as_setBannerData(CurrentProperties.BannerItems[CurrentBannerItemIndex]);
    }
    CurrentBannerProgress = 0.0;
    //return;    
}

function ScrollToPreviousBannerItem()
{
    // End:0xA2
    if(CurrentProperties.BannerItems.Length > 0)
    {
        CurrentBannerItemIndex = CurrentBannerItemIndex - 1;
        // End:0xA2
        if(CurrentBannerItemIndex < 0)
        {
            CurrentBannerItemIndex = CurrentProperties.BannerItems.Length - 1;
            as_setBannerData(CurrentProperties.BannerItems[CurrentBannerItemIndex]);
        }
    }
    CurrentBannerProgress = 0.0;
    //return;    
}

event SetSwitchTimeRatio(float InRatio)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x62
    if(BoundObject != none)
    {
        BoundObject.SetString("bannerProgress", "" $ string(InRatio));
    }
    //return;    
}

function as_setBannerData(AnnouncementDialogBoxBannerItem BannerItem)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x51
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("setBannerData");
    }
    //return;    
}

event as_ScrollNewsPanel(int Direction)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x53
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("scrollNewsPanel");
    }
    //return;    
}

function as_SetNumofItems(int ItemCount)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x57
    if(BoundObject != none)
    {
        BoundObject.SetInt("numOfItems", ItemCount);
    }
    //return;    
}

defaultproperties
{
    TimePerBannerImage=5.0
    LocStringDefaultHeaderText="NEWS & NOTES"
    LocStringDefaultBodyText="<p align='center'><font size='20'>Welcome to Blacklight!</p><br><p><font size='16'></font></p><br><br><p align='center'><font size='12' color='#78AEBC'>Welcome to the soft beta of BLR v.3.0, complete with new game servers, new weapon balances, and a host of other improvements and fixes. Additional information can be found at /r/Blacklight. </font></p>"
    DefaultBannerItems(0)=(BackgroundImageRef="img://ui_icons.store.t_GenericNewsBanner",BackgroundImageURL="",IconRef="",IconRef2="",TextLocTag="")
    LocStringCloseButtonText="CLOSE"
    CloseButtonIcon="img://Menu.t_cancelIcon"
}